; ROUTINE FOR FILTER FOR CARRIAGE RETURN/LINEFEED
;
; Function:
;       This routine filters a file, replacing carraige returns by carriage
;       returns/line feeds. Tabs are expanded
; Registers used:
;       This is the main program of an EXE command file.
;
controlz        equ     1Ah     ; control Z
;
        extrn   stdinne:far,stdout:far
;
;***************************************************************************
datas   segment public
;
lastbyte        db      0
;
datas   ends
;****************************************************************************
stacks  segment stack
        db      20 dup('stack   ')
stacks  ends
;*****************************************************************************
codes   segment
'
        assume  cs:codes,ds:datas
;
; ROUTINE TO FILTER FILES FOR CARRIAGE RETURNS
;
crfilter        proc    far
;
; set up return
        push    ds              ; save for proper return
        mov     ax,0            ; points to beginning of segment
        push    ax              ; for the offset
;
; set up segments
        mov     ax,datas        ; new data segment
        mov     ds,ax           ; put in DS
        mov     es,ax           ; and in ES
;
; main loop
crfilter1:
;
; get thr next character
        call    stdinne         ; get the character with out echo
;
; strip off bit 7
        and     al,7Fh          ; just 7 bits
;
; check for line feed
        cmp     al,10           ; ASCII 10
        jne     crfilter2       ; skip if not line feed
        cmp     lastbyte,13     ; was lastbyte a carraige return ?
        je      crfilter3       ; skip if cr/lf
;
crfilter2:
        call    stdout          ; send it out
        mov     lastbyte,al     ; update lastbyte
;
; check for carriage return
crfilter3:
        cmp     al,13           ; ASCII 13
        jne     crfilter4       ; skip if so
;
        push    ax              ; save current character
        mov     al,10           ; put a linfeed
        call    stdout          ; out the stdard output
        pop     ax              ; restore current character
;
; check for end of file
crfilter4:
        cmp     al,controlz     ; end of file ?
        jne     crfilter1       ; if not, back for more
;
; exit
crfilterexit:
        ret
;
crfilter        endp
codes   ends                    ; end of code segment
        end     crfilter
;
