; ROUTINE TO INSERT A WORD IN AN ORDERED LIST OF WORDS
;
; Input:
;       On entry DS:BX points to a source word string.
;       ES:BP points to the ordered list of words
;       The source word string starts with a 16-bit integer which is it's length
;       The last byte must be a carriage return symbol (ASCII 13)
;       The desination list begins with a 16-bit integer specifing the length
;       in character bytes. It continues with words of ASCII characters
;       separated by carriage return symbols.
; Output:
;       On exit the list has the string inserted in proper place.
; Registers used:
;       No registers are modified.
; Segments referenced:
;       On entry the data segment contains the source, and the extra segment
;       contains the destination word list and must be equal
;
lexinsert       proc    far
;
        push    ax              ; save registers
;
        call    lexsearch       ; search for match
        cmp     al,0            ; already there ?
        je      lexinsertexit   ; skip if so
        call    strinsert       ; insert the new word
;
lexinsertexit:
        pop     ax              ; restore registers
        ret
;
lexinsert       endp
;
