; ROUTINE TO MULTIPLY MULTIDIGIT BINARY NUMBERS
;
mbinmul proc    far
;
        push    si              ; save registers
        push    di
        push    bx
        push    cx
        push    ax
;
; clear result buffer
        push    bx              ; save result pointer BX
        mov     ax,0            ; get a zero
        mov     cx,2*isize      ; double precision for this number
        cld                     ; forward direction
mbinmul1:
        mov     [bx],ax         ; clear the "digit"
        inc     bx              ; point to next "digit"
        inc     bx
        loop    mbinmul1        ; loop through all "digits"
        pop     bx              ; restore result pointer BX
;
        mov     cx,isize        ; get the number of 16-bit "digits"
mbinmul2:
        push    cx              ; save count for outer loop
        mov     dx,[si]         ; get "digit" from first number
        inc     si              ; point to next "digit"
        inc     si
;
        push    bx              ; save registers during inner loop
        push    di
;
        mov     cx,isize        ; get the number of 16-bit "digits"
mbinmul3:
        push    cx              ; save count for inner loop
        push    dx              ; save multiplier "digit"
        mov     ax,[di]         ; get "digit" from second number
        inc     di              ; point to next "digit"
        inc     di
        mul     dx              ; multiply
        add     [bx],ax         ; add lower "digit" to result
        inc     bx              ; point to next "digit"
        inc     bx
        adc     [bx],dx         ; add upper part to result
        pop     dx              ; restore multiplier
        pop     cx              ; restore count for inner loop
        loop    mbinmul3        ; loop through all "digits" of second
;
        pop     di              ; restore registers
        pop     bx
;
        inc     bx              ; shift by one "digit"
        inc     bx
        pop     cx              ; restore count for outer loop
        loop    mbinmul2        ; loop through all "digits" of first
;
        pop     ax              ; restore registers
        pop     cx
        pop     bx
        pop     di
        pop     si
        ret
;
mbinmul endp
