; ROUTINE TO PUT ONE BYTE INTO A CIRCULAR BUFFER
;
;  Input:
;       On entry a byte is in AL
;  Output:
;       The byte goes into the circular buffer. The pointers and guage variables
;       are properly adjusted. If the buffer gets nearly full then a routine
;       is called to send a signal to the communications device to stop
;       sending any more bytes of output.
;  Registers used:
;       DI is the buffer pointer.
;  Segments referenced:
;       On entry the data segment must contain the circular buffer and
;       the variables CBUFF, GAUGE, & LASTBYTE
;  Routines called:     COMOFF
;
putcbuff        proc    far
;
; put the byte into the buffer
        mov     cbuff[di],al    ; byte goes into buffer
;
; adjust pointer
        inc     di              ; point to next character
        cmp     di,cbuffsize    ; wrap it around ?
        jne     putbuff1        ; skip if no wrap
        mov     di,0            ; wraps back to zero
;
; count it
putcbuff1:
        inc     guage           ; count the character
        cmp     guage,nearfull  ; too many characters ?
        jne     putcbuff2       ; skip if not
        call    comoff          ; request to stop flow
putcbuff2:
;
putcbuffret:
        ret
;
putcbuff        endp
;
