; ROUTINE TO SEARCH FOR ONE STRING WITHIN ANOTHER
;
; Input:
;       Upon entry DS:BX points to a source string and ES:DX points to a
;       destination string. Each string begins with a 16-bit integer which
;       specifies its length.
;
;  Segments referenced:
;       Upon entry the data segment must contain the scource string.
;       The extra segment must contain the destination string.
;
;  Output:
;       Upon exit AL contains a return flag (0=not found, 0FFh=found)
;       DX contains the location of the first byte of the match in destination.
;
;  Registers used:
;       AX, DX are modified and used for output
;
strsearch       proc    far
;
        push    si              ; save registers
        push    di
        push    cx
;
; get length of destination and point to first byte
        mov     si,dx           ; use source index
        lodsw                   ; get the length of destination
        mov     cx,ax           ; use the length as a count
        mov     dx,si           ; text begins here
;
strsearch1:
; point indicies to beginning of source and destination
        mov     si,bx           ; load source index
        mov     di,dx           ; load destination index
;
; scan for match
        mov     al,[si+2]       ; get the first character
        cld                     ; forward direction
        repnz   scasb           ; scan for match
        jcxz    strsearch2      ; quit if found no match
;
; get a match of first characters - now check the entire string
        mov     dx,di           ; save current destination loc
        dec     di              ; beginning of a word
        lodsw                   ; get length of source
        xchg    cx,ax           ; use source count and save dest count
        repz    cmpsb           ; compare the two strings
        jcxz    strsearch3      ; it's amatch if no more source
;
; continue the scan
        xchg    cx,ax           ;use destination count
        jmp     strsearch1      ; back for more scanning of dest
;
; no match is possible
strsearch2:
        mov     al,0            ; unsuccessful outcome
        jmp     strsearchexit
;
; found a match
strsearch3:
        dec     dx              ; point to beginning of match
        mov     al,0FFh         ; successful match
        jmp     strsearchexit
;
strsearchexit:
;
        pop     cx              ; restore registers
        pop     di
        pop     si
        ret
;
strsearch       endp
;
