; ROUTINE TO WRITE A BYTE TO A FILE
;
;  Input:
;       BX contains file handle.
;       DS:DX points to a linear buffer containing the bytes
;       CX contains the byte count
;  Output:
;       On success the bytes are written and the carry is clear.
;       Failure, the carry is set and error code is in AX
;  Registers used:
;       AX & BX are used for input - AX for output.
;  Segments referenced:
;       Data segment must contain the linear byte buffer LBUFF.
;  Routines called:
;       DOS call 40h(write to a file)
;
writefile       proc    far
;
        mov     ah,40h          ; write to file
        int     21h             ; DOS call
        cmp     ax,cx           ; was it all written ?
        je      writefile1      ; skip if ok
        mov     ax,21           ; not all bytes were transfered
        stc                     ; set carry if error
;
writefile1:
        ret
;
writefile       endp
;
