; ROUTINE TO XOR A POINT ON A MEDIUM RES COLOR SCREEN
;
xorpt   proc    far
;
        push    bx              ; save registers
        push    si
        push    ax
;
; multiply y-coord by bytes per row and adjust for even/odd lines
        mov     ax,di           ; get y-coord into low part
        mov     ah,al           ;  and into high part
        and     ax,01FEh        ; mask off unwanted parts
        sal     ax,1            ; times 4
        sal     ax,1            ; times 8
        sal     ax,1            ; times 16
        mov     bx,ax           ; goes into address
        and     bh,7            ; without adjustment
        sal     ax,1            ; times 32
        sal     ax,1            ; times 64
        add     bx,ax           address gets y-coord times 80
;
; add x-coord to address
        mov     ax,si           ; get x-coordinate
        sar     ax,1            ; divide
        sar     ax,1            ;  by 4
        add     bx,ax           ; here is the address
;
; compute the mask for color and use it
        and     si,3            ; just pixel postion into the index
        sal     si,1            ; index times 2
        sal     si,1            ; index times 4
        add     si,dx           ; 4*pixel position + color
        sal     si,1            ; 8*pixel position + 2*color
        mov     ax,ctable[si]   ; look up rotated color and mask
        xor     es:[bx],ah      ; xor the byte with the color
;
        pop     ax              ; restore registers
        pop     si
        pop     bx
        ret
;
xorpt   endp

